/**
 * generated by Xtext 2.21.0
 */
package br.ufes.nemo.seon.ontoloyasservice.oaas.impl;

import br.ufes.nemo.seon.ontoloyasservice.oaas.About;
import br.ufes.nemo.seon.ontoloyasservice.oaas.AbstractElement;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Application;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Attribute;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Author;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Author_Email;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Configuration;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Description;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Entity;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Entity_Type;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Function;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Import;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Level;
import br.ufes.nemo.seon.ontoloyasservice.oaas.ManyToMany;
import br.ufes.nemo.seon.ontoloyasservice.oaas.OaasFactory;
import br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage;
import br.ufes.nemo.seon.ontoloyasservice.oaas.OneToMany;
import br.ufes.nemo.seon.ontoloyasservice.oaas.OneToOne;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Ontology;
import br.ufes.nemo.seon.ontoloyasservice.oaas.OntologyShortName;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Relation;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Repository;
import br.ufes.nemo.seon.ontoloyasservice.oaas.Software;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class OaasFactoryImpl extends EFactoryImpl implements OaasFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static OaasFactory init()
  {
    try
    {
      OaasFactory theOaasFactory = (OaasFactory)EPackage.Registry.INSTANCE.getEFactory(OaasPackage.eNS_URI);
      if (theOaasFactory != null)
      {
        return theOaasFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new OaasFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OaasFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case OaasPackage.APPLICATION: return createApplication();
      case OaasPackage.CONFIGURATION: return createConfiguration();
      case OaasPackage.ONTOLOGY: return createOntology();
      case OaasPackage.LEVEL: return createLevel();
      case OaasPackage.AUTHOR: return createAuthor();
      case OaasPackage.AUTHOR_EMAIL: return createAuthor_Email();
      case OaasPackage.REPOSITORY: return createRepository();
      case OaasPackage.ONTOLOGY_SHORT_NAME: return createOntologyShortName();
      case OaasPackage.SOFTWARE: return createSoftware();
      case OaasPackage.ABOUT: return createAbout();
      case OaasPackage.DESCRIPTION: return createDescription();
      case OaasPackage.ENTITY_TYPE: return createEntity_Type();
      case OaasPackage.MODULE: return createModule();
      case OaasPackage.ABSTRACT_ELEMENT: return createAbstractElement();
      case OaasPackage.IMPORT: return createImport();
      case OaasPackage.ENTITY: return createEntity();
      case OaasPackage.ATTRIBUTE: return createAttribute();
      case OaasPackage.RELATION: return createRelation();
      case OaasPackage.ONE_TO_ONE: return createOneToOne();
      case OaasPackage.MANY_TO_MANY: return createManyToMany();
      case OaasPackage.ONE_TO_MANY: return createOneToMany();
      case OaasPackage.FUNCTION: return createFunction();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Application createApplication()
  {
    ApplicationImpl application = new ApplicationImpl();
    return application;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Configuration createConfiguration()
  {
    ConfigurationImpl configuration = new ConfigurationImpl();
    return configuration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Ontology createOntology()
  {
    OntologyImpl ontology = new OntologyImpl();
    return ontology;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Level createLevel()
  {
    LevelImpl level = new LevelImpl();
    return level;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Author createAuthor()
  {
    AuthorImpl author = new AuthorImpl();
    return author;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Author_Email createAuthor_Email()
  {
    Author_EmailImpl author_Email = new Author_EmailImpl();
    return author_Email;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Repository createRepository()
  {
    RepositoryImpl repository = new RepositoryImpl();
    return repository;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public OntologyShortName createOntologyShortName()
  {
    OntologyShortNameImpl ontologyShortName = new OntologyShortNameImpl();
    return ontologyShortName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Software createSoftware()
  {
    SoftwareImpl software = new SoftwareImpl();
    return software;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public About createAbout()
  {
    AboutImpl about = new AboutImpl();
    return about;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Description createDescription()
  {
    DescriptionImpl description = new DescriptionImpl();
    return description;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Entity_Type createEntity_Type()
  {
    Entity_TypeImpl entity_Type = new Entity_TypeImpl();
    return entity_Type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public br.ufes.nemo.seon.ontoloyasservice.oaas.Module createModule()
  {
    ModuleImpl module = new ModuleImpl();
    return module;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public AbstractElement createAbstractElement()
  {
    AbstractElementImpl abstractElement = new AbstractElementImpl();
    return abstractElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Import createImport()
  {
    ImportImpl import_ = new ImportImpl();
    return import_;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Entity createEntity()
  {
    EntityImpl entity = new EntityImpl();
    return entity;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Attribute createAttribute()
  {
    AttributeImpl attribute = new AttributeImpl();
    return attribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Relation createRelation()
  {
    RelationImpl relation = new RelationImpl();
    return relation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public OneToOne createOneToOne()
  {
    OneToOneImpl oneToOne = new OneToOneImpl();
    return oneToOne;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ManyToMany createManyToMany()
  {
    ManyToManyImpl manyToMany = new ManyToManyImpl();
    return manyToMany;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public OneToMany createOneToMany()
  {
    OneToManyImpl oneToMany = new OneToManyImpl();
    return oneToMany;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Function createFunction()
  {
    FunctionImpl function = new FunctionImpl();
    return function;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public OaasPackage getOaasPackage()
  {
    return (OaasPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static OaasPackage getPackage()
  {
    return OaasPackage.eINSTANCE;
  }

} //OaasFactoryImpl
